﻿-- Monitor Setup
------------------------------------------------------------------------------------------
--Cooldowns-------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
function SN:CoolDowns()
	
	local f = SN.F
	local m = SN.Media
	--Make the frames db local
	local v = SN.db.profile.Frames

	f.cooldowns = SN:MakeFrame("CDGroup", "cooldowns", "SN:arg4", 24)
	f.cooldowns:SetScript("OnEvent", function(self, event, ...)
		SN:EventHandler(self, event, ...)
	end)
	f.cooldowns.name = "Cooldown Monitor"
	--Register our events for the frame
	f.cooldowns:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	f.cooldowns:RegisterEvent("PLAYER_REGEN_DISABLED")
	f.cooldowns:RegisterEvent("SPELL_UPDATE_USABLE")
end
------------------------------------------------------------------------------------------
--Debuffs---------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
function SN:Debuffs()
	
	local f = SN.F
	local m = SN.Media
	--make the frames db local
	local v = SN.db.profile.Frames
	
	f.debuffs = SN:MakeFrame("DBGroup", "debuffs", "SN:arg4", 20)
	f.debuffs:SetScript("OnEvent", function(self, event, ...)
		if SN.db.profile.debuffs.enable then
			SN:EventHandler(self, event, ...)
		end
	end)
	f.debuffs.name = "Debuff Monitor"
	--Register our events for the frame
	f.debuffs:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end
------------------------------------------------------------------------------------------
-- Threat module--------------------------------------------------------------------------
------------------------------------------------------------------------------------------
function SN:SetupThreat()
	
	--Funtime with variables
	local f = SN.F
	local m = SN.Media
	local v = SN.db.profile.Frames

	f.threat = CreateFrame("Frame", threat, UIParent)
	f.threat:SetPoint(unpack(v.threat))
	f.threat:SetWidth(250)
	f.threat:SetHeight(100)
	f.threat:SetClampedToScreen(true)

	f.threat:SetScript("OnEvent", function(self, event, ...)
		SN:EventHandler(self, event, ...)
	end)

	f.threat.value = f.threat:CreateFontString(nil, "ARTWORK")
	f.threat.value:SetFont(m.media.font, 24, "OUTLINE")
	f.threat.value:SetTextColor(0.78, 0.25, 0.25)
	f.threat.value:SetText("")
	f.threat.value:SetAllPoints(f.threat)
	f.threat.value:SetJustifyH("CENTER")
	f.threat.value:SetJustifyV("MIDDLE")
	
	--Register the events for this frame
	f.threat:RegisterEvent("UNIT_THREAT_LIST_UPDATE")
	f.threat:RegisterEvent("UNIT_THREAT_SITUATION_UPDATE")
	f.threat:RegisterEvent("PLAYER_REGEN_ENABLED")
	f.threat:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	f.threat:RegisterEvent("UNIT_SPELLCAST_SENT")
	f.threat.name = "Threat Monitor"
	
end
------------------------------------------------------------------------------------------
-- Dispel module--------------------------------------------------------------------------
------------------------------------------------------------------------------------------
local dispelSpell

function SN:SetupDispel()
	
	local f = SN.F
	local m = SN.Media
	local v = SN.db.profile.Frames

	f.dispel = CreateFrame("Frame", dispel, UIParent)
	f.dispel:SetPoint(unpack(v.dispel))
	f.dispel:SetWidth(250)
	f.dispel:SetHeight(50)
	f.dispel:SetClampedToScreen(true)
	
	f.dispel.TimeSinceLastUpdate = 0
	f.dispel.frameLocked = 1
	f.dispel.name = "Dispel Monitor"
	f.dispel:SetScript("OnUpdate", function(self, elapsed)
		if SN.db.profile.dispel.enable then
			SN:SearchBuffs(self, elapsed)
		end
	end)
	f.dispel:SetScript("OnEvent", function(self, event, ...)
		if SN.db.profile.dispel.enable then
			SN:EventHandler(self, event, ...)
		end
	end)
	f.dispel.value = f.dispel:CreateFontString(nil, "ARTWORK")
	f.dispel.value:SetFont(m.media.font, 16, "OUTLINE")
	f.dispel.value:SetTextColor(0.78, 0.25, 0.25)
	f.dispel.value:SetText("")
	f.dispel.value:SetAllPoints(f.dispel)
	f.dispel.value:SetJustifyH("CENTER")
	f.dispel.value:SetJustifyV("MIDDLE")
	
	f.dispel:RegisterEvent("PLAYER_REGEN_ENABLED")
	f.dispel:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	f.dispel:RegisterEvent("PLAYER_TARGET_CHANGED")
end

function SN:SearchBuffs(self, elapsed)
	--Make sure we don't hog cpu cycles checking it every millisecond
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed
	if self.TimeSinceLastUpdate > SN_UpdateInterval then

		self.TimeSinceLastUpdate = 0
		
		for i = 1, 40 do

			local stealableBuffs -- i = { }, 1
			local name, _, icon, _, debuffType, _, _, _, _, _, spellId, _, _ = UnitAura("target", i, "HELPFUL")
				
			if name ~= nil then
				self.dispelSpell = dispelSpell
				canDispel, dispelSpell = SN.dispel:CanDispel("target", true, debuffType, spellId)
				if canDispel then
					self.value:SetText("You can "..GetSpellLink(dispelSpell).."\n\n"..name.." from "..UnitName("target"))
				end
			end
		end
	end
end
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
